

public class BTNode<E> {
	
	public E data;
	public BTNode<E> left;
	public BTNode<E> right;
	
	public BTNode(E data) {
		this(data, null, null);
	}
	
	public BTNode(E data, BTNode<E> left, BTNode<E> right) {
		this.data = data;
		this.left = left;
		this.right = right;
	}

	public static abstract class Visitor<E> {
		public abstract void visit (BTNode<E> node);
		public void beforeVisit() {
			
		}
		public void afterVisit() {
			
		}
	}
}
