
public class BinarySearchTree<E extends Comparable<E>> {

	private BTNode<E> root;

	public BinarySearchTree() {
		root = null;
	}

	public void insert(E data) {
		root = insert(root, data);
	}

	/**
	  * insert item into tree rooted at node
	  *
	  * @param node
	  *            root of current subtree
	  * @param data
	  *            item to be inserted in tree
	  */
	private BTNode<E> insert(BTNode<E> node, E data) {
		return null;
	}

	public void remove(E data) {
		root = remove(root, data);
	}
	
	/**
	  * remove target from tree rooted at node
	  *
	  * @param node
	  *            node at top of current sub-tree that may contain target
	  * @param data
	  *            item to be removed if it exists in tree
	  */
	private BTNode<E> remove(BTNode<E> node, E data) {
		return null;
	}

	/**
	  * Find the rightmost node (largest value), disconnect it from the tree, and
	  * return its data.
	  * 
	  * Preconditions: node and parent are not null.
	  *
	  * @param parent
	  *            parent of this node so that it can be deleted
	  * @param node
	  *            current node that potentially is rightmost
	  * @return the data from the rightmost node which has been removed
	  */
	private E removeLargest(BTNode<E> parent, BTNode<E> node) {
		return null;
	}
	
	/**
	 * Replaces old child with new child in parent's links. Figures out whether it
	 * was a left or right child.
	 *
	 * Precondition: parent is not null.
	 *
	 * @param parent
	 *            node that has children with one needing replacement
	 * @param oldChild
	 *            node that will be discarded
	 * @param newChild
	 *            node that will be attached in oldChild's place
	 */
	private void replaceChild (BTNode<E> parent, BTNode<E> oldChild, BTNode<E> newChild) {
		
	}

	public String toString() {
		BSTUtils.StringPrinter<E> printer = new BSTUtils.StringPrinter<E>();
		BSTUtils.inorder(root, printer);
		return printer.toString();
	}

	public void print() {
		BSTUtils.reverseInorder(root, new BSTUtils.TreePrinter<E>());
	}
}
